package core.services;

import core.api.models.timemanager.taskgroup.TaskgroupEntityInfo;
import core.api.models.timemanager.taskgroup.TaskgroupFieldInfo;
import core.entities.timemanager.Taskgroup;
import core.repositories.timemanager.TaskgroupRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.config.Task;
import org.springframework.stereotype.Service;

@Service
public class TaskgroupService {

    private final TaskgroupRepository taskgroupRepository;
    public TaskgroupService(@Autowired  TaskgroupRepository taskgroupRepository) {
        this.taskgroupRepository = taskgroupRepository;
    }

    public ServiceResult<Taskgroup> addTaskgroup(TaskgroupFieldInfo taskData) {
        if(!taskgroupRepository.existsByTaskgroupName(taskData.getName())) {
            Taskgroup taskgroup = new Taskgroup(taskData.getName());
            taskgroupRepository.save(taskgroup);
            return new ServiceResult<>(taskgroup);
        } else {
            return new ServiceResult<>(ServiceExitCode.ENTITY_ALREADY_EXIST);
        }
    }
}
